Subject: bug#25101: closed (Re: bug#25101: [PATCH 1/2] gnu: Add hpaio-enabled sane-backends variant.)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 17 Dec 2016 22:13:02 +0000

Your bug report

#25101: simple-scan can't use hpaio

which was filed against the guix package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
25101: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=25101
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#25101: [PATCH 1/2] gnu: Add hpaio-enabled sane-backends variant.
From: [email-masked] (Ludovic Courtès)
To: Andy Patterson <[email-masked]>
Cc: [email-masked]
Date: Sat, 17 Dec 2016 23:12:41 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello!

Andy Patterson <[email-masked]> skribis:

> Here's some patches implementing what you've suggested. I decided to use the
> full "sane-backends" for the other dependents, since I guessed that they need
> some backend support. If anyone knows that that's not required, it can be
> changed.

I think that’s fine.

Applied all 3 patches.  I also fixed a reproducibility issue due to
timestamps in a subsequent commit.

Thanks!

Ludo’.

Subject: simple-scan can't use hpaio
From: Danny Milosavljevic <[email-masked]>
To: <[email-masked]>
Date: Sat, 3 Dec 2016 19:41:13 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

simple-scan can't use hpaio as scanner. That means that HP scanners don't work at all.

That's because:

(1) sane-backends installs a hard-coded dll.conf . In itself, that's not so bad. However, this file doesn't contain a line "hpaio". 
    To workaround this, I set environment variable SANE_CONFIG_DIR to point to a directory which contains a dll.conf which contains (only) a line "hpaio".
(2) sane-backends tries to load /gnu/store/f4kmkdf8s0kpwia9wgiw5a35xljh4a77-sane-backends-1.0.25/lib/sane/libsane-hpaio.so.1 - which won't work. 
    I checked the source code of sane-backends - and it searches many locations for loadable dynamic libraries, for example the ones specified in environment variables LD_LIBRARY_PATH, SHLIB_PATH LIBPATH (see backend/dll.c load()). 
(3) dll.conf has no support for absolute paths. Whatever you put there it will just blindly put after a hard-coded directory prefix.

This is on GuixSD.

How to proceed? Add support for absolute paths and a service which merges multiple dll.conf into one file ?

Or just add hplip as a hard dependency of sane-backends and make it link libsane-hpaio (that's possible in sane)?

Also, should we also amend simple-scan to propagate-input hplip? Otherwise it will come up with a "Install Driver" dialog which won't work either.